/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.cosmodas.EntCosmos;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "productosucursal")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "Productosucursal.findAll", query = "SELECT p FROM Productosucursal p"),
        @NamedQuery(name = "Productosucursal.findBySucursalCodigo", query = "SELECT p FROM Productosucursal p WHERE p.productosucursalPK.sucursalCodigo = :sucursalCodigo"),
        @NamedQuery(name = "Productosucursal.findByProductoCodigo", query = "SELECT p FROM Productosucursal p WHERE p.productosucursalPK.productoCodigo = :productoCodigo"),
        @NamedQuery(name = "Productosucursal.findByProductoSucursalExistenciaAnterior", query = "SELECT p FROM Productosucursal p WHERE p.productoSucursalExistenciaAnterior = :productoSucursalExistenciaAnterior"),
        @NamedQuery(name = "Productosucursal.findByProductoSucursalExistenciaActual", query = "SELECT p FROM Productosucursal p WHERE p.productoSucursalExistenciaActual = :productoSucursalExistenciaActual"),
        @NamedQuery(name = "Productosucursal.findByProductoSucursalFisica", query = "SELECT p FROM Productosucursal p WHERE p.productoSucursalFisica = :productoSucursalFisica"),
        @NamedQuery(name = "Productosucursal.findByExistenciaTricoder", query = "SELECT p FROM Productosucursal p WHERE p.existenciaTricoder = :existenciaTricoder")})
public class Productosucursal implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected ProductosucursalPK productosucursalPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "producto_sucursal_existencia_anterior")
    private int productoSucursalExistenciaAnterior;
    @Basic(optional = false)
    @NotNull
    @Column(name = "producto_sucursal_existencia_actual")
    private int productoSucursalExistenciaActual;
    @Basic(optional = false)
    @NotNull
    @Column(name = "producto_sucursal_fisica")
    private int productoSucursalFisica;
    @Column(name = "existencia_tricoder")
    private Integer existenciaTricoder;
    @JoinColumn(name = "producto_codigo", referencedColumnName = "producto_codigo", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Productos productos;

    public Productosucursal() {
    }

    public Productosucursal(ProductosucursalPK productosucursalPK) {
        this.productosucursalPK = productosucursalPK;
    }

    public Productosucursal(ProductosucursalPK productosucursalPK, int productoSucursalExistenciaAnterior, int productoSucursalExistenciaActual, int productoSucursalFisica) {
        this.productosucursalPK = productosucursalPK;
        this.productoSucursalExistenciaAnterior = productoSucursalExistenciaAnterior;
        this.productoSucursalExistenciaActual = productoSucursalExistenciaActual;
        this.productoSucursalFisica = productoSucursalFisica;
    }

    public Productosucursal(String sucursalCodigo, String productoCodigo) {
        this.productosucursalPK = new ProductosucursalPK(sucursalCodigo, productoCodigo);
    }

    public ProductosucursalPK getProductosucursalPK() {
        return productosucursalPK;
    }

    public void setProductosucursalPK(ProductosucursalPK productosucursalPK) {
        this.productosucursalPK = productosucursalPK;
    }

    public int getProductoSucursalExistenciaAnterior() {
        return productoSucursalExistenciaAnterior;
    }

    public void setProductoSucursalExistenciaAnterior(int productoSucursalExistenciaAnterior) {
        this.productoSucursalExistenciaAnterior = productoSucursalExistenciaAnterior;
    }

    public int getProductoSucursalExistenciaActual() {
        return productoSucursalExistenciaActual;
    }

    public void setProductoSucursalExistenciaActual(int productoSucursalExistenciaActual) {
        this.productoSucursalExistenciaActual = productoSucursalExistenciaActual;
    }

    public int getProductoSucursalFisica() {
        return productoSucursalFisica;
    }

    public void setProductoSucursalFisica(int productoSucursalFisica) {
        this.productoSucursalFisica = productoSucursalFisica;
    }

    public Integer getExistenciaTricoder() {
        return existenciaTricoder;
    }

    public void setExistenciaTricoder(Integer existenciaTricoder) {
        this.existenciaTricoder = existenciaTricoder;
    }

    public Productos getProductos() {
        return productos;
    }

    public void setProductos(Productos productos) {
        this.productos = productos;
    }

//    @Override
//    public int hashCode() {
//        int hash = 0;
//        hash += (productosucursalPK != null ? productosucursalPK.hashCode() : 0);
//        return hash;
//    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Productosucursal)) {
            return false;
        }
        Productosucursal other = (Productosucursal) object;
        if ((this.productosucursalPK == null && other.productosucursalPK != null) || (this.productosucursalPK != null && !this.productosucursalPK.equals(other.productosucursalPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "dbCon.Productosucursal[ productosucursalPK=" + productosucursalPK + " ]";
    }

}
